"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class AlternateCoordinate(ProtocolElement):
    """
    No documentation
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "alternate",
        "type",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        return {}

    @classmethod
    def getEmbeddedEnums(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_0 import opencb as opencb_1_3_1

        return {
            "type": opencb_1_3_1.VariantType,
        }

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_0 import opencb as opencb_1_3_1

        return {
            "org.opencb.biodata.models.variant.avro.VariantType": opencb_1_3_1.VariantType,
            "org.opencb.biodata.models.variant.avro.AlternateCoordinate": opencb_1_3_1.AlternateCoordinate,
        }

    __slots__ = [
        "alternate",
        "type",
        "chromosome",
        "end",
        "reference",
        "start",
    ]

    def __init__(
        self,
        alternate,
        type,
        chromosome=None,
        end=None,
        reference=None,
        start=None,
        validate=None,
        **kwargs
    ):
        """Initialise the opencb_1_3_1.AlternateCoordinate model.

        :param alternate:
            * Alternate allele.
        :type alternate: str
        :param type:
        :type type: VariantType
        :param chromosome:
        :type chromosome: None | str
        :param end:
            * End position 1-based of the alternate. If null, the end is the same
            of the variant.
        :type end: None | int
        :param reference:
            * Reference allele. If null, the reference is the same of the variant.
        :type reference: None | str
        :param start:
            * First position 1-based of the alternate. If null, the start is the
            same of the variant.
        :type start: None | int
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "1.3.1"
